# seres-client
API for the Seres core platform

This Python package is automatically generated by the [OpenAPI Generator](https://openapi-generator.tech) project:

- API version: 0.1.0
- Package version: 0.0.30
- Generator version: 7.9.0
- Build package: org.openapitools.codegen.languages.PythonClientCodegen

## Requirements.

Python 3.7+

## Installation & Usage
### pip install

If the python package is hosted on a repository, you can install directly using:

```sh
pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git
```
(you may need to run `pip` with root permission: `sudo pip install git+https://github.com/GIT_USER_ID/GIT_REPO_ID.git`)

Then import the package:
```python
import seres_client
```

### Setuptools

Install via [Setuptools](http://pypi.python.org/pypi/setuptools).

```sh
python setup.py install --user
```
(or `sudo python setup.py install` to install the package for all users)

Then import the package:
```python
import seres_client
```

### Tests

Execute `pytest` to run the tests.

## Getting Started

Please follow the [installation procedure](#installation--usage) and then run the following:

```python

import seres_client
from seres_client.rest import ApiException
from pprint import pprint

# Defining the host is optional and defaults to http://localhost
# See configuration.py for a list of all supported configuration parameters.
configuration = seres_client.Configuration(
    host = "http://localhost"
)

# The client must configure the authentication and authorization parameters
# in accordance with the API server security policy.
# Examples for each auth method are provided below, use the example that
# satisfies your auth use case.

# Configure API key authorization: APIKeyHeader
configuration.api_key['APIKeyHeader'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['APIKeyHeader'] = 'Bearer'

# Configure API key authorization: APIKeyCookie
configuration.api_key['APIKeyCookie'] = os.environ["API_KEY"]

# Uncomment below to setup prefix (e.g. Bearer) for API key, if needed
# configuration.api_key_prefix['APIKeyCookie'] = 'Bearer'


# Enter a context with an instance of the API client
with seres_client.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = seres_client.AccessKeysApi(api_client)
    access_key_creation_schema = seres_client.AccessKeyCreationSchema() # AccessKeyCreationSchema | 

    try:
        # Create Access Key
        api_response = api_instance.create_access_key(access_key_creation_schema)
        print("The response of AccessKeysApi->create_access_key:\n")
        pprint(api_response)
    except ApiException as e:
        print("Exception when calling AccessKeysApi->create_access_key: %s\n" % e)

```

## Documentation for API Endpoints

All URIs are relative to *http://localhost*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AccessKeysApi* | [**create_access_key**](docs/AccessKeysApi.md#create_access_key) | **POST** /api/access-keys | Create Access Key
*AccessKeysApi* | [**disable_access_key**](docs/AccessKeysApi.md#disable_access_key) | **POST** /api/access-keys/{access_key_id}/disable | Disable Access Key
*AccessKeysApi* | [**get_access_key**](docs/AccessKeysApi.md#get_access_key) | **GET** /api/access-keys/{access_key_id} | Get Access Key
*AccessKeysApi* | [**get_access_key_me**](docs/AccessKeysApi.md#get_access_key_me) | **GET** /api/access-keys/me | Get Access Key Me
*AccessKeysApi* | [**get_access_keys**](docs/AccessKeysApi.md#get_access_keys) | **GET** /api/access-keys | Get Access Keys
*AccessKeysApi* | [**reactivate_access_key**](docs/AccessKeysApi.md#reactivate_access_key) | **POST** /api/access-keys/{access_key_id}/reactivate | Reactivate Access Key
*AuthenticationApi* | [**login**](docs/AuthenticationApi.md#login) | **POST** /api/login | Login
*AuthenticationApi* | [**logout**](docs/AuthenticationApi.md#logout) | **POST** /api/logout | Logout
*AvailableResourceAssembliesApi* | [**get_available_assemblies**](docs/AvailableResourceAssembliesApi.md#get_available_assemblies) | **GET** /api/available-resource-assemblies | Get Available Assemblies
*FlightPlanCreationRequestsApi* | [**create_mission_plan_creation_request**](docs/FlightPlanCreationRequestsApi.md#create_mission_plan_creation_request) | **POST** /api/mission-plan-creation-requests | Create Mission Plan Creation Request
*FlightPlanCreationRequestsApi* | [**get_mission_plan_creation_request**](docs/FlightPlanCreationRequestsApi.md#get_mission_plan_creation_request) | **GET** /api/mission-plan-creation-requests/{request_id} | Get Mission Plan Creation Request
*FlightPlanCreationRequestsApi* | [**get_mission_plan_creation_requests**](docs/FlightPlanCreationRequestsApi.md#get_mission_plan_creation_requests) | **GET** /api/mission-plan-creation-requests | Get Mission Plan Creation Requests
*FlightPlanLegResourcesApi* | [**cancel_mission_plan_leg_resource**](docs/FlightPlanLegResourcesApi.md#cancel_mission_plan_leg_resource) | **DELETE** /api/mission-plan-leg-resources/{leg_resource_id} | Cancel Mission Plan Leg Resource
*FlightPlanLegResourcesApi* | [**create_mission_plan_leg_resource**](docs/FlightPlanLegResourcesApi.md#create_mission_plan_leg_resource) | **POST** /api/mission-plan-leg-resources | Create Mission Plan Leg Resource
*FlightPlanLegsApi* | [**cancel_mission_plan_leg**](docs/FlightPlanLegsApi.md#cancel_mission_plan_leg) | **DELETE** /api/mission-plan-legs/{mission_plan_leg_id} | Cancel Mission Plan Leg
*FlightPlanLegsApi* | [**create_mission_plan_leg**](docs/FlightPlanLegsApi.md#create_mission_plan_leg) | **POST** /api/mission-plan-legs | Create Mission Plan Leg
*FlightPlanReferencesApi* | [**get_mission_plan_reference**](docs/FlightPlanReferencesApi.md#get_mission_plan_reference) | **GET** /api/mission-plan-references/{mission_plan_id} | Get Mission Plan Reference
*FlightPlanReferencesApi* | [**get_mission_plan_references**](docs/FlightPlanReferencesApi.md#get_mission_plan_references) | **GET** /api/mission-plan-references | Get Mission Plan References
*FlightPlanWaypointsApi* | [**cancel_mission_plan_waypoint**](docs/FlightPlanWaypointsApi.md#cancel_mission_plan_waypoint) | **DELETE** /api/mission-plan-waypoints/{mission_plan_waypoint_id} | Cancel Mission Plan Waypoint
*FlightPlanWaypointsApi* | [**create_mission_plan_waypoint**](docs/FlightPlanWaypointsApi.md#create_mission_plan_waypoint) | **POST** /api/mission-plan-waypoints | Create Mission Plan Waypoint
*FlightPlansApi* | [**create_mission_plan**](docs/FlightPlansApi.md#create_mission_plan) | **POST** /api/mission-plans | Create Mission Plan
*FlightPlansApi* | [**delete_mission_plan**](docs/FlightPlansApi.md#delete_mission_plan) | **DELETE** /api/mission-plans/{mission_plan_id} | Delete Mission Plan
*FlightPlansApi* | [**get_mission_plan**](docs/FlightPlansApi.md#get_mission_plan) | **GET** /api/mission-plans/{mission_plan_id} | Get Mission Plan
*FlightPlansApi* | [**get_mission_plans**](docs/FlightPlansApi.md#get_mission_plans) | **GET** /api/mission-plans | Get Mission Plans
*FutureActivitiesApi* | [**get_future_activities**](docs/FutureActivitiesApi.md#get_future_activities) | **GET** /api/future-activities | Get Future Activities
*FuturesApi* | [**commit_future**](docs/FuturesApi.md#commit_future) | **POST** /api/futures/{future_id}/commit | Commit Future
*FuturesApi* | [**create_future**](docs/FuturesApi.md#create_future) | **POST** /api/futures | Create Future
*FuturesApi* | [**delete_future**](docs/FuturesApi.md#delete_future) | **DELETE** /api/futures/{future_id} | Delete Future
*FuturesApi* | [**get_future**](docs/FuturesApi.md#get_future) | **GET** /api/futures/{future_id} | Get Future
*FuturesApi* | [**get_futures**](docs/FuturesApi.md#get_futures) | **GET** /api/futures | Get Futures
*FuturesApi* | [**verify_future**](docs/FuturesApi.md#verify_future) | **GET** /api/futures/{future_id}/verify | Verify Future
*MissionTemplateLegsApi* | [**create_mission_template_leg**](docs/MissionTemplateLegsApi.md#create_mission_template_leg) | **POST** /api/mission-plan-template-legs | Create Mission Template Leg
*MissionTemplateLegsApi* | [**delete_mission_template_leg**](docs/MissionTemplateLegsApi.md#delete_mission_template_leg) | **DELETE** /api/mission-plan-template-legs/{mission_template_leg_id} | Delete Mission Template Leg
*MissionTemplateLegsApi* | [**get_mission_template_leg**](docs/MissionTemplateLegsApi.md#get_mission_template_leg) | **GET** /api/mission-plan-template-legs/{mission_template_leg_id} | Get Mission Template Leg
*MissionTemplateLegsApi* | [**get_mission_template_legs**](docs/MissionTemplateLegsApi.md#get_mission_template_legs) | **GET** /api/mission-plan-template-legs | Get Mission Template Legs
*MissionTemplateLegsApi* | [**update_mission_template_leg**](docs/MissionTemplateLegsApi.md#update_mission_template_leg) | **PATCH** /api/mission-plan-template-legs/{mission_template_leg_id} | Update Mission Template Leg
*MissionTemplateWaypointsApi* | [**create_mission_template_waypoint**](docs/MissionTemplateWaypointsApi.md#create_mission_template_waypoint) | **POST** /api/mission-plan-template-waypoints | Create Mission Template Waypoint
*MissionTemplateWaypointsApi* | [**delete_mission_template_waypoint**](docs/MissionTemplateWaypointsApi.md#delete_mission_template_waypoint) | **DELETE** /api/mission-plan-template-waypoints/{mission_template_waypoint_id} | Delete Mission Template Waypoint
*MissionTemplateWaypointsApi* | [**get_mission_template_waypoint**](docs/MissionTemplateWaypointsApi.md#get_mission_template_waypoint) | **GET** /api/mission-plan-template-waypoints/{mission_template_waypoint_id} | Get Mission Template Waypoint
*MissionTemplateWaypointsApi* | [**get_mission_template_waypoints**](docs/MissionTemplateWaypointsApi.md#get_mission_template_waypoints) | **GET** /api/mission-plan-template-waypoints | Get Mission Template Waypoints
*MissionTemplateWaypointsApi* | [**update_mission_template_waypoint**](docs/MissionTemplateWaypointsApi.md#update_mission_template_waypoint) | **PATCH** /api/mission-plan-template-waypoints/{mission_template_waypoint_id} | Update Mission Template Waypoint
*MissionTemplatesApi* | [**activate_mission_template**](docs/MissionTemplatesApi.md#activate_mission_template) | **POST** /api/mission-plan-templates/{mission_template_id}/activate | Activate Mission Template
*MissionTemplatesApi* | [**create_mission_template**](docs/MissionTemplatesApi.md#create_mission_template) | **POST** /api/mission-plan-templates | Create Mission Template
*MissionTemplatesApi* | [**create_mission_template_revision**](docs/MissionTemplatesApi.md#create_mission_template_revision) | **POST** /api/mission-plan-templates/{mission_template_id}/revision | Create Mission Template Revision
*MissionTemplatesApi* | [**create_mission_template_variation**](docs/MissionTemplatesApi.md#create_mission_template_variation) | **POST** /api/mission-plan-templates/{mission_template_id}/variation | Create Mission Template Variation
*MissionTemplatesApi* | [**decommission_mission_template**](docs/MissionTemplatesApi.md#decommission_mission_template) | **POST** /api/mission-plan-templates/{mission_template_id}/decommission | Decommission Mission Template
*MissionTemplatesApi* | [**delete_mission_template**](docs/MissionTemplatesApi.md#delete_mission_template) | **DELETE** /api/mission-plan-templates/{mission_template_id} | Delete Mission Template
*MissionTemplatesApi* | [**get_mission_template**](docs/MissionTemplatesApi.md#get_mission_template) | **GET** /api/mission-plan-templates/{mission_template_id} | Get Mission Template
*MissionTemplatesApi* | [**get_mission_templates**](docs/MissionTemplatesApi.md#get_mission_templates) | **GET** /api/mission-plan-templates | Get Mission Templates
*MissionTemplatesApi* | [**update_mission_template**](docs/MissionTemplatesApi.md#update_mission_template) | **PATCH** /api/mission-plan-templates/{mission_template_id} | Update Mission Template
*PadWindowsApi* | [**get_pad_window**](docs/PadWindowsApi.md#get_pad_window) | **GET** /api/pad-windows/{window_id} | Get Pad Window
*PadWindowsApi* | [**get_pad_windows**](docs/PadWindowsApi.md#get_pad_windows) | **GET** /api/pad-windows | Get Pad Windows
*PortsApi* | [**get_port**](docs/PortsApi.md#get_port) | **GET** /api/ports/{port_id} | Get Port
*PortsApi* | [**get_ports**](docs/PortsApi.md#get_ports) | **GET** /api/ports | Get Ports
*ResourceAssemblySchemaEnergyBankComponentsApi* | [**get_resource_assembly_schema_energy_bank_component**](docs/ResourceAssemblySchemaEnergyBankComponentsApi.md#get_resource_assembly_schema_energy_bank_component) | **GET** /api/resource-assembly-schema-energy-bank-components/{energy_bank_component_id} | Get Resource Assembly Schema Energy Bank Component
*ResourceAssemblySchemaEnergyBankComponentsApi* | [**get_resource_assembly_schema_energy_bank_components**](docs/ResourceAssemblySchemaEnergyBankComponentsApi.md#get_resource_assembly_schema_energy_bank_components) | **GET** /api/resource-assembly-schema-energy-bank-components | Get Resource Assembly Schema Energy Bank Components
*ResourceAssemblySchemaEnergyBankConsumersApi* | [**get_resource_assembly_schema_energy_bank_consumer**](docs/ResourceAssemblySchemaEnergyBankConsumersApi.md#get_resource_assembly_schema_energy_bank_consumer) | **GET** /api/resource-assembly-schema-energy-bank-consumers/{energy_bank_consumer_id} | Get Resource Assembly Schema Energy Bank Consumer
*ResourceAssemblySchemaEnergyBankConsumersApi* | [**get_resource_assembly_schema_energy_bank_consumers**](docs/ResourceAssemblySchemaEnergyBankConsumersApi.md#get_resource_assembly_schema_energy_bank_consumers) | **GET** /api/resource-assembly-schema-energy-bank-consumers | Get Resource Assembly Schema Energy Bank Consumers
*ResourceAssemblySchemaEnergyBanksApi* | [**get_resource_assembly_schema_energy_bank**](docs/ResourceAssemblySchemaEnergyBanksApi.md#get_resource_assembly_schema_energy_bank) | **GET** /api/resource-assembly-schema-energy-banks/{energy_bank_id} | Get Resource Assembly Schema Energy Bank
*ResourceAssemblySchemaEnergyBanksApi* | [**get_resource_assembly_schema_energy_banks**](docs/ResourceAssemblySchemaEnergyBanksApi.md#get_resource_assembly_schema_energy_banks) | **GET** /api/resource-assembly-schema-energy-banks | Get Resource Assembly Schema Energy Banks
*ResourceAssemblySchemaRefuelSwapsApi* | [**get_resource_assembly_schema_refuel_swap**](docs/ResourceAssemblySchemaRefuelSwapsApi.md#get_resource_assembly_schema_refuel_swap) | **GET** /api/resource-assembly-schema-refuel-swaps/{swap_id} | Get Resource Assembly Schema Refuel Swap
*ResourceAssemblySchemaRefuelSwapsApi* | [**get_resource_assembly_schema_refuel_swaps**](docs/ResourceAssemblySchemaRefuelSwapsApi.md#get_resource_assembly_schema_refuel_swaps) | **GET** /api/resource-assembly-schema-refuel-swaps | Get Resource Assembly Schema Refuel Swaps
*ResourceAssemblySchemasApi* | [**get_resource_assembly_schema**](docs/ResourceAssemblySchemasApi.md#get_resource_assembly_schema) | **GET** /api/resource-assembly-schemas/{resource_assembly_schema_id} | Get Resource Assembly Schema
*ResourceAssemblySchemasApi* | [**get_resource_assembly_schemas**](docs/ResourceAssemblySchemasApi.md#get_resource_assembly_schemas) | **GET** /api/resource-assembly-schemas | Get Resource Assembly Schemas
*ResourceSchemaActionSchemasApi* | [**get_resource_schema_action_schema**](docs/ResourceSchemaActionSchemasApi.md#get_resource_schema_action_schema) | **GET** /api/resource-schema-action-schemas/{resource_schema_action_schema_id} | Get Resource Schema Action Schema
*ResourceSchemaActionSchemasApi* | [**get_resource_schema_action_schemas**](docs/ResourceSchemaActionSchemasApi.md#get_resource_schema_action_schemas) | **GET** /api/resource-schema-action-schemas | Get Resource Schema Action Schemas
*ResourceSchemaActionsApi* | [**get_resource_schema_action**](docs/ResourceSchemaActionsApi.md#get_resource_schema_action) | **GET** /api/resource-schema-actions/{resource_schema_action_id} | Get Resource Schema Action
*ResourceSchemaActionsApi* | [**get_resource_schema_actions**](docs/ResourceSchemaActionsApi.md#get_resource_schema_actions) | **GET** /api/resource-schema-actions | Get Resource Schema Actions
*ResourceSchemasApi* | [**get_resource_schema**](docs/ResourceSchemasApi.md#get_resource_schema) | **GET** /api/resource-schemas/{resource_schema_id} | Get Resource Schema
*ResourceSchemasApi* | [**get_resource_schema_preview**](docs/ResourceSchemasApi.md#get_resource_schema_preview) | **GET** /api/resource-schemas/{resource_schema_id}/preview.glb | Get Resource Schema Preview
*ResourceSchemasApi* | [**get_resource_schemas**](docs/ResourceSchemasApi.md#get_resource_schemas) | **GET** /api/resource-schemas | Get Resource Schemas
*ResourcesApi* | [**get_resource**](docs/ResourcesApi.md#get_resource) | **GET** /api/resources/{resource_id} | Get Resource
*ResourcesApi* | [**get_resources**](docs/ResourcesApi.md#get_resources) | **GET** /api/resources | Get Resources
*SubnetsApi* | [**get_subnet**](docs/SubnetsApi.md#get_subnet) | **GET** /api/subnets/{subnet_id} | Get Subnet
*SubnetsApi* | [**get_subnets**](docs/SubnetsApi.md#get_subnets) | **GET** /api/subnets | Get Subnets
*UsersApi* | [**create_user**](docs/UsersApi.md#create_user) | **POST** /api/users | Create User
*UsersApi* | [**delete_user**](docs/UsersApi.md#delete_user) | **DELETE** /api/users/{user_id} | Delete User
*UsersApi* | [**disable_user**](docs/UsersApi.md#disable_user) | **POST** /api/users/{user_id}/disable | Disable User
*UsersApi* | [**get_me**](docs/UsersApi.md#get_me) | **GET** /api/users/me | Get Me
*UsersApi* | [**get_platform_user**](docs/UsersApi.md#get_platform_user) | **GET** /api/users/{user_id} | Get Platform User
*UsersApi* | [**get_users**](docs/UsersApi.md#get_users) | **GET** /api/users | Get Users
*UsersApi* | [**reactivate_user**](docs/UsersApi.md#reactivate_user) | **POST** /api/users/{user_id}/reactivate | Reactivate User


## Documentation For Models

 - [AccessKeyCreationSchema](docs/AccessKeyCreationSchema.md)
 - [AccessKeySchema](docs/AccessKeySchema.md)
 - [AccessKeyStatusEnum](docs/AccessKeyStatusEnum.md)
 - [Altitude](docs/Altitude.md)
 - [AppMissionsPlansSchemasMissionPlanWaypointSchemaWaypointCoordinateSchemaInput](docs/AppMissionsPlansSchemasMissionPlanWaypointSchemaWaypointCoordinateSchemaInput.md)
 - [AppMissionsPlansSchemasMissionPlanWaypointSchemaWaypointCoordinateSchemaOutput](docs/AppMissionsPlansSchemasMissionPlanWaypointSchemaWaypointCoordinateSchemaOutput.md)
 - [AppMissionsTemplatesSchemasMissionTemplateWaypointSchemaWaypointCoordinateSchemaInput](docs/AppMissionsTemplatesSchemasMissionTemplateWaypointSchemaWaypointCoordinateSchemaInput.md)
 - [AppMissionsTemplatesSchemasMissionTemplateWaypointSchemaWaypointCoordinateSchemaOutput](docs/AppMissionsTemplatesSchemasMissionTemplateWaypointSchemaWaypointCoordinateSchemaOutput.md)
 - [AvailableResourceAssemblySchemaComponentResourceSchemaActionSchema](docs/AvailableResourceAssemblySchemaComponentResourceSchemaActionSchema.md)
 - [AvailableResourceAssemblySchemaComponentSchema](docs/AvailableResourceAssemblySchemaComponentSchema.md)
 - [AvailableResourceAssemblySchemaSchema](docs/AvailableResourceAssemblySchemaSchema.md)
 - [AverageSpeed](docs/AverageSpeed.md)
 - [ConfigurationEnum](docs/ConfigurationEnum.md)
 - [Elevation](docs/Elevation.md)
 - [ExpectedStatus](docs/ExpectedStatus.md)
 - [FutureActivitySchema](docs/FutureActivitySchema.md)
 - [FutureActivityType](docs/FutureActivityType.md)
 - [FutureCreationSchema](docs/FutureCreationSchema.md)
 - [FutureEntityType](docs/FutureEntityType.md)
 - [FutureSchema](docs/FutureSchema.md)
 - [HTTPValidationError](docs/HTTPValidationError.md)
 - [ImplementationStatusEnum](docs/ImplementationStatusEnum.md)
 - [Latitude](docs/Latitude.md)
 - [LoginResponseSchema](docs/LoginResponseSchema.md)
 - [LoginSchema](docs/LoginSchema.md)
 - [Longitude](docs/Longitude.md)
 - [MissionPlanCreationRequestCreationSchema](docs/MissionPlanCreationRequestCreationSchema.md)
 - [MissionPlanCreationRequestSchema](docs/MissionPlanCreationRequestSchema.md)
 - [MissionPlanCreationRequestStatusEnum](docs/MissionPlanCreationRequestStatusEnum.md)
 - [MissionPlanCreationSchema](docs/MissionPlanCreationSchema.md)
 - [MissionPlanLegCreationSchema](docs/MissionPlanLegCreationSchema.md)
 - [MissionPlanLegResourceCreationSchema](docs/MissionPlanLegResourceCreationSchema.md)
 - [MissionPlanLegResourceSchema](docs/MissionPlanLegResourceSchema.md)
 - [MissionPlanLegSchema](docs/MissionPlanLegSchema.md)
 - [MissionPlanReferenceSchema](docs/MissionPlanReferenceSchema.md)
 - [MissionPlanSchema](docs/MissionPlanSchema.md)
 - [MissionPlanTypeEnum](docs/MissionPlanTypeEnum.md)
 - [MissionPlanWaypointCreationSchema](docs/MissionPlanWaypointCreationSchema.md)
 - [MissionPlanWaypointSchema](docs/MissionPlanWaypointSchema.md)
 - [MissionTemplateCreationSchema](docs/MissionTemplateCreationSchema.md)
 - [MissionTemplateLegCreationSchema](docs/MissionTemplateLegCreationSchema.md)
 - [MissionTemplateLegImmediateCreationSchema](docs/MissionTemplateLegImmediateCreationSchema.md)
 - [MissionTemplateLegSchema](docs/MissionTemplateLegSchema.md)
 - [MissionTemplateLegUpdateSchema](docs/MissionTemplateLegUpdateSchema.md)
 - [MissionTemplateRevisionCreationSchema](docs/MissionTemplateRevisionCreationSchema.md)
 - [MissionTemplateSchema](docs/MissionTemplateSchema.md)
 - [MissionTemplateType](docs/MissionTemplateType.md)
 - [MissionTemplateUpdateSchema](docs/MissionTemplateUpdateSchema.md)
 - [MissionTemplateVariationCreationSchema](docs/MissionTemplateVariationCreationSchema.md)
 - [MissionTemplateWaypointCreationSchema](docs/MissionTemplateWaypointCreationSchema.md)
 - [MissionTemplateWaypointImmediateCreationSchema](docs/MissionTemplateWaypointImmediateCreationSchema.md)
 - [MissionTemplateWaypointSchema](docs/MissionTemplateWaypointSchema.md)
 - [MissionTemplateWaypointUpdateSchema](docs/MissionTemplateWaypointUpdateSchema.md)
 - [MovementDomainType](docs/MovementDomainType.md)
 - [NewEntityIdSchema](docs/NewEntityIdSchema.md)
 - [PadWindowSchema](docs/PadWindowSchema.md)
 - [PaginatedResponseSchemaAccessKeySchema](docs/PaginatedResponseSchemaAccessKeySchema.md)
 - [PaginatedResponseSchemaFutureActivitySchema](docs/PaginatedResponseSchemaFutureActivitySchema.md)
 - [PaginatedResponseSchemaMissionPlanCreationRequestSchema](docs/PaginatedResponseSchemaMissionPlanCreationRequestSchema.md)
 - [PaginatedResponseSchemaMissionPlanReferenceSchema](docs/PaginatedResponseSchemaMissionPlanReferenceSchema.md)
 - [PaginatedResponseSchemaMissionTemplateSchema](docs/PaginatedResponseSchemaMissionTemplateSchema.md)
 - [PaginatedResponseSchemaResourceAssemblySchemaSchema](docs/PaginatedResponseSchemaResourceAssemblySchemaSchema.md)
 - [PaginatedResponseSchemaResourceSchema](docs/PaginatedResponseSchemaResourceSchema.md)
 - [PaginatedResponseSchemaResourceSchemaSchema](docs/PaginatedResponseSchemaResourceSchemaSchema.md)
 - [PaginatedResponseSchemaUserSchema](docs/PaginatedResponseSchemaUserSchema.md)
 - [PermissionSchema](docs/PermissionSchema.md)
 - [PortCoordinate](docs/PortCoordinate.md)
 - [PortSchema](docs/PortSchema.md)
 - [ResourceAssemblySchemaComponentSchema](docs/ResourceAssemblySchemaComponentSchema.md)
 - [ResourceAssemblySchemaEnergyBankComponentSchema](docs/ResourceAssemblySchemaEnergyBankComponentSchema.md)
 - [ResourceAssemblySchemaEnergyBankConsumerSchema](docs/ResourceAssemblySchemaEnergyBankConsumerSchema.md)
 - [ResourceAssemblySchemaEnergyBankSchema](docs/ResourceAssemblySchemaEnergyBankSchema.md)
 - [ResourceAssemblySchemaRefuelSwapSchema](docs/ResourceAssemblySchemaRefuelSwapSchema.md)
 - [ResourceAssemblySchemaSchema](docs/ResourceAssemblySchemaSchema.md)
 - [ResourceSchema](docs/ResourceSchema.md)
 - [ResourceSchemaActionSchema](docs/ResourceSchemaActionSchema.md)
 - [ResourceSchemaActionSchemaSchema](docs/ResourceSchemaActionSchemaSchema.md)
 - [ResourceSchemaEnergyProfileSchema](docs/ResourceSchemaEnergyProfileSchema.md)
 - [ResourceSchemaSchema](docs/ResourceSchemaSchema.md)
 - [ResourceTypeEnum](docs/ResourceTypeEnum.md)
 - [SubnetSchema](docs/SubnetSchema.md)
 - [UserCreationSchema](docs/UserCreationSchema.md)
 - [UserSchema](docs/UserSchema.md)
 - [UserStatusEnum](docs/UserStatusEnum.md)
 - [ValidationError](docs/ValidationError.md)
 - [ValidationErrorLocInner](docs/ValidationErrorLocInner.md)


<a id="documentation-for-authorization"></a>
## Documentation For Authorization


Authentication schemes defined for the API:
<a id="APIKeyCookie"></a>
### APIKeyCookie

- **Type**: API key
- **API key parameter name**: token
- **Location**: 

<a id="APIKeyHeader"></a>
### APIKeyHeader

- **Type**: API key
- **API key parameter name**: Authorization
- **Location**: HTTP header


## Author




