# coding: utf-8

"""
    Secore API

    API for the Seres core platform

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from pydantic import BaseModel, ConfigDict, Field, StrictBool, StrictInt
from typing import Any, ClassVar, Dict, List, Optional
from typing_extensions import Annotated
from seres_client.models.mission_plan_type_enum import MissionPlanTypeEnum
from typing import Optional, Set
from typing_extensions import Self

class MissionPlanCreationSchema(BaseModel):
    """
    MissionPlanCreationSchema
    """ # noqa: E501
    reference: Annotated[str, Field(strict=True, max_length=120)]
    mission_template_id: Optional[StrictInt] = None
    parent_mission_plan_id: Optional[StrictInt] = None
    account_id: StrictInt
    is_private: Optional[StrictBool] = False
    type: Optional[MissionPlanTypeEnum] = None
    __properties: ClassVar[List[str]] = ["reference", "mission_template_id", "parent_mission_plan_id", "account_id", "is_private", "type"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MissionPlanCreationSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if mission_template_id (nullable) is None
        # and model_fields_set contains the field
        if self.mission_template_id is None and "mission_template_id" in self.model_fields_set:
            _dict['mission_template_id'] = None

        # set to None if parent_mission_plan_id (nullable) is None
        # and model_fields_set contains the field
        if self.parent_mission_plan_id is None and "parent_mission_plan_id" in self.model_fields_set:
            _dict['parent_mission_plan_id'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MissionPlanCreationSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "reference": obj.get("reference"),
            "mission_template_id": obj.get("mission_template_id"),
            "parent_mission_plan_id": obj.get("parent_mission_plan_id"),
            "account_id": obj.get("account_id"),
            "is_private": obj.get("is_private") if obj.get("is_private") is not None else False,
            "type": obj.get("type")
        })
        return _obj


