# coding: utf-8

"""
    Secore API

    API for the Seres core platform

    The version of the OpenAPI document: 0.1.0
    Generated by OpenAPI Generator (https://openapi-generator.tech)

    Do not edit the class manually.
"""  # noqa: E501


from __future__ import annotations
import pprint
import re  # noqa: F401
import json

from datetime import datetime
from pydantic import BaseModel, ConfigDict, StrictInt, StrictStr
from typing import Any, ClassVar, Dict, List, Optional
from seres_client.models.expected_status import ExpectedStatus
from seres_client.models.mission_plan_type_enum import MissionPlanTypeEnum
from typing import Optional, Set
from typing_extensions import Self

class MissionPlanReferenceSchema(BaseModel):
    """
    MissionPlanReferenceSchema
    """ # noqa: E501
    id: StrictInt
    expected_status: ExpectedStatus
    type: MissionPlanTypeEnum
    future_id: StrictInt
    mission_template_id: Optional[StrictInt]
    parent_mission_plan_id: Optional[StrictInt]
    account_id: StrictInt
    reference: StrictStr
    created_by_id: StrictInt
    starting_datetime: Optional[datetime]
    ending_datetime: Optional[datetime]
    __properties: ClassVar[List[str]] = ["id", "expected_status", "type", "future_id", "mission_template_id", "parent_mission_plan_id", "account_id", "reference", "created_by_id", "starting_datetime", "ending_datetime"]

    model_config = ConfigDict(
        populate_by_name=True,
        validate_assignment=True,
        protected_namespaces=(),
    )


    def to_str(self) -> str:
        """Returns the string representation of the model using alias"""
        return pprint.pformat(self.model_dump(by_alias=True))

    def to_json(self) -> str:
        """Returns the JSON representation of the model using alias"""
        # TODO: pydantic v2: use .model_dump_json(by_alias=True, exclude_unset=True) instead
        return json.dumps(self.to_dict())

    @classmethod
    def from_json(cls, json_str: str) -> Optional[Self]:
        """Create an instance of MissionPlanReferenceSchema from a JSON string"""
        return cls.from_dict(json.loads(json_str))

    def to_dict(self) -> Dict[str, Any]:
        """Return the dictionary representation of the model using alias.

        This has the following differences from calling pydantic's
        `self.model_dump(by_alias=True)`:

        * `None` is only added to the output dict for nullable fields that
          were set at model initialization. Other fields with value `None`
          are ignored.
        """
        excluded_fields: Set[str] = set([
        ])

        _dict = self.model_dump(
            by_alias=True,
            exclude=excluded_fields,
            exclude_none=True,
        )
        # set to None if mission_template_id (nullable) is None
        # and model_fields_set contains the field
        if self.mission_template_id is None and "mission_template_id" in self.model_fields_set:
            _dict['mission_template_id'] = None

        # set to None if parent_mission_plan_id (nullable) is None
        # and model_fields_set contains the field
        if self.parent_mission_plan_id is None and "parent_mission_plan_id" in self.model_fields_set:
            _dict['parent_mission_plan_id'] = None

        # set to None if starting_datetime (nullable) is None
        # and model_fields_set contains the field
        if self.starting_datetime is None and "starting_datetime" in self.model_fields_set:
            _dict['starting_datetime'] = None

        # set to None if ending_datetime (nullable) is None
        # and model_fields_set contains the field
        if self.ending_datetime is None and "ending_datetime" in self.model_fields_set:
            _dict['ending_datetime'] = None

        return _dict

    @classmethod
    def from_dict(cls, obj: Optional[Dict[str, Any]]) -> Optional[Self]:
        """Create an instance of MissionPlanReferenceSchema from a dict"""
        if obj is None:
            return None

        if not isinstance(obj, dict):
            return cls.model_validate(obj)

        _obj = cls.model_validate({
            "id": obj.get("id"),
            "expected_status": obj.get("expected_status"),
            "type": obj.get("type"),
            "future_id": obj.get("future_id"),
            "mission_template_id": obj.get("mission_template_id"),
            "parent_mission_plan_id": obj.get("parent_mission_plan_id"),
            "account_id": obj.get("account_id"),
            "reference": obj.get("reference"),
            "created_by_id": obj.get("created_by_id"),
            "starting_datetime": obj.get("starting_datetime"),
            "ending_datetime": obj.get("ending_datetime")
        })
        return _obj


